//PROFILES ----------------------------------------------------------------

new AudioProfile (ShellOverSound_T2)
{
	fileName = "./T2buttonOver.wav";
	description = "AudioGui";
	preload = 1;
};
new AudioProfile (ShellDownSound_T2 : ShellOverSound_T2)
{
	fileName = "./T2buttonDown.wav";
};
new AudioProfile (ShellDownSound_MB : ShellOverSound_T2)
{
	fileName = "./MBbuttonPress.wav";
};

new AudioProfile (ShellOverSound_HL1 : ShellOverSound_T2)
{
	fileName = "./HL1buttonrollover.wav";
};
new AudioProfile (ShellDownSound_HL1 : ShellOverSound_T2)
{
	fileName = "./HL1buttonclickrelease.wav";
};

new AudioProfile (ShellOverSound_HL2 : ShellOverSound_T2)
{
	fileName = "./HL2buttonrollover.wav";
};
new AudioProfile (ShellDownSound_HL2 : ShellOverSound_T2)
{
	fileName = "./HL2buttonclickrelease.wav";
};

new AudioProfile (ShellOverSound_Custom : ShellOverSound_T2)
{
	fileName = "./T2buttonOver.wav";
};
new AudioProfile (ShellDownSound_Custom : ShellOverSound_T2)
{
	fileName = "./T2buttonDown.wav";
};

new GuiControlProfile (UISound_ButtonSilentProfile : BlockButtonProfile) //window controls are silent, so the help button should be too
{
	soundButtonDown = "";
	soundButtonOver = "";
};

//UI LISTS ----------------------------------------------------------------

if(!isObject(UISound_SelectGui))
	exec("./UISound_SelectGui.gui");

function UISound_OverList::init (%this)
{
	%i = 0;
	if (%this.findText ("NONE") == -1)
	{
		%this.add ("NONE", 0);
	}
	if (%this.findText ("CUSTOM") == -1)
	{
		%this.add ("CUSTOM", %i++);
	}
	if (%this.findText ("Tribes 2") == -1)
	{
		%this.add ("Tribes 2", %i++);
	}
	if (%this.findText ("Half-Life") == -1)
	{
		%this.add ("Half-Life", %i++);
	}
	if (%this.findText ("Half-Life 2") == -1)
	{
		%this.add ("Half-Life 2", %i++);
	}
}

function UISound_DownList::init (%this)
{
	%i = 0;
	if (%this.findText ("NONE") == -1)
	{
		%this.add ("NONE", 0);
	}
	if (%this.findText ("CUSTOM") == -1)
	{
		%this.add ("CUSTOM", %i++);
	}
	if (%this.findText ("Tribes 2") == -1)
	{
		%this.add ("Tribes 2", %i++);
	}
	if (%this.findText ("Marble Blast") == -1)
	{
		%this.add ("Marble Blast", %i++);
	}
	if (%this.findText ("Half-Life") == -1)
	{
		%this.add ("Half-Life", %i++);
	}
	if (%this.findText ("Half-Life 2") == -1)
	{
		%this.add ("Half-Life 2", %i++);
	}
}

$UISound_Over["NONE"] = "";
$UISound_Over["CUSTOM"] = ShellOverSound_Custom;
$UISound_Over["Tribes 2"] = ShellOverSound_T2;
$UISound_Over["Half-Life"] = ShellOverSound_HL1;
$UISound_Over["Half-Life 2"] = ShellOverSound_HL2;

$UISound_Down["NONE"] = "";
$UISound_Down["CUSTOM"] = ShellDownSound_Custom;
$UISound_Down["Tribes 2"] = ShellDownSound_T2;
$UISound_Down["Marble Blast"] = ShellDownSound_MB;
$UISound_Down["Half-Life"] = ShellDownSound_HL1;
$UISound_Down["Half-Life 2"] = ShellDownSound_HL2;

//UI       ----------------------------------------------------------------

function UISound_UpdateCustomSounds (%down, %over)
{
	// if(isObject(ShellOverSound_Custom))
	// {
		// ShellOverSound_Custom.delete();
	// }
	// if(isObject(ShellDownSound_Custom))
	// {
		// ShellDownSound_Custom.delete();
	// }
		
	// new AudioProfile(ShellOverSound_Custom : ShellOverSound_T2)
	// {
		// fileName = %over;
	// };
	// new AudioProfile(ShellDownSound_Custom : ShellOverSound_T2)
	// {
		// fileName = %down;
	// };
	
	// $UISound_Over["CUSTOM"] = ShellOverSound_Custom;
	// $UISound_Down["CUSTOM"] = ShellDownSound_Custom;
	
	// this is what custom chat does, but the ability to delete sound datablocks is missing in rebuilt. oh well, changing the sound filename directly seems to work well enough
	
	ShellOverSound_Custom.fileName = %over;
	ShellDownSound_Custom.fileName = %down;
}

function UISound_Apply ()
{
	$Pref::UISound::Down = UISound_DownList.getText();
	$Pref::UISound::Over = UISound_OverList.getText();
	
	if(($Pref::UISound::CustomDown !$= $UISound::TempCustomDown) || ($Pref::UISound::CustomOver !$= $UISound::TempCustomOver))
	{
		UISound_UpdateCustomSounds($UISound::TempCustomDown, $UISound::TempCustomOver);
	}

	$Pref::UISound::CustomDown = $UISound::TempCustomDown;
	$Pref::UISound::CustomOver = $UISound::TempCustomOver;
	
	UISound_SetProfiles();
}

function UISound_SetProfiles ()
{	
	%ShellDownSound = $UISound_Down[$Pref::UISound::Down];
	%ShellOverSound = $UISound_Over[$Pref::UISound::Over];
	
	guiDefaultProfile.soundButtonDown = %ShellDownSound;
	guiDefaultProfile.soundButtonOver = %ShellOverSound;

	guiButtonProfile.soundButtonDown = %ShellDownSound;
	guiButtonProfile.soundButtonOver = %ShellOverSound;

	guiButtonSmProfile.soundButtonDown = %ShellDownSound;
	guiButtonSmProfile.soundButtonOver = %ShellOverSound;

	guiCheckBoxProfile.soundButtonDown = %ShellDownSound;
	guiCheckBoxProfile.soundButtonOver = %ShellOverSound;

	guiRadioProfile.soundButtonDown = %ShellDownSound;
	guiRadioProfile.soundButtonOver = %ShellOverSound;

	blockButtonProfile.soundButtonDown = %ShellDownSound;
	blockButtonProfile.soundButtonOver = %ShellOverSound;

	BlockCheckBoxProfile.soundButtonDown = %ShellDownSound;
	BlockCheckBoxProfile.soundButtonOver = %ShellOverSound;

	BlockRadioProfile.soundButtonDown = %ShellDownSound;
	BlockRadioProfile.soundButtonOver = %ShellOverSound; 
}

new GuiButtonCtrl(UISound_OpenButton)
{
	profile = "BlockButtonProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	//position = "10 258";
	position = "100 1"; //v20
	extent = "100 22";
	minExtent = "8 2";
	enabled = true;
	visible = true;
	clipToParent = true;
	command = "UISound_OpenDialog();";
	text = "UI Sounds";
	groupNum = -1;
	buttonType = "PushButton";
};

if(isFunction("isBlocklandRebuilt") && isBlocklandRebuilt())
{
	UISound_OpenButton.extent = "100 18";
	UISound_OpenButton.position = "112 4";
	OptGraphicsPane.getObject(0).add(UISound_OpenButton); //temporary hack until we get that proper client pref menu
	UISound_TestButton.setBitmap("base/client/ui/button3"); //use the default button3 texture if available, otherwise use my own from add-on folder
} else {
	OptGraphicsPane.getObject(3).add(UISound_OpenButton);
}

if($Pref::UISound::CustomOver $= "") //apply default prefs
{
	$Pref::UISound::Over = "NONE";
	$Pref::UISound::Down = "NONE";
	
	$Pref::UISound::CustomDown = "./T2buttonDown.wav";
	$Pref::UISound::CustomOver = "./T2buttonOver.wav";
}

UISound_OverList.init();
UISound_DownList.init();

UISound_OverList.setValue($Pref::UISound::Over);
UISound_DownList.setValue($Pref::UISound::Down);
$UISound::TempCustomDown = $Pref::UISound::CustomDown;
$UISound::TempCustomOver = $Pref::UISound::CustomOver;

function UISound_OpenDialog() {
	UISound_OverList.setValue($Pref::UISound::Over);
	UISound_DownList.setValue($Pref::UISound::Down);
	$UISound::TempCustomDown = $Pref::UISound::CustomDown;
	$UISound::TempCustomOver = $Pref::UISound::CustomOver;
	
	canvas.pushDialog(UISound_SelectGui);
}

function UISound_Help() { //maybe this could be replaced with a more in-depth help menu, but i think this is enough
	MessageBoxOK ("Help", "To use custom sounds, write the location of the sound file in the Blockland directory.<br><br>Starting with ./ points to this add-on's folder.<br>You can also provide your own sounds in WAV format by putting them somewhere in your Blockland directory.<br><br>A good place to put them might be to make a \"/sound\" folder in the config/client folder.");
}

UISound_UpdateCustomSounds($Pref::UISound::CustomDown, $Pref::UISound::CustomOver);
UISound_SetProfiles();